/*  Meade LX200 commandを送るプログラム
    引数が3つ必要
    引数1 コマンド文字列
    引数2 -s もしくは -r :-sは送信のみで受信の無いコマンドで使用、-rは送受信のコマンドで使用
    引数3 コマンド文字列の文字数(:と#も含む)
    開発・最終改定:2012/02/19 沖田博文 (東北大・天文・D2) */

#include <stdio.h>	/*入出力標準ライブラリ*/
#include <termios.h>	/*非同期通信ポートを制御する為の汎用ターミナルインターフェース*/
#include <fcntl.h>	/*ファイル操作(低水準入出力関数)*/
#include <unistd.h>	/*standard symbolic constants and types */
#include <string.h>
#include <stdlib.h>

int main(int argc, char *argv[] ){

    struct termios tio;
    int fd;
    FILE *fpp;
    char callback[256]="Z";

    /* ファイルオープン */
    fd=open("/dev/ttyUSB0",O_RDWR | O_NOCTTY);
    fpp=fopen("/dev/ttyUSB0","r");

    if(fd<0){
        printf("Error: Cannot open the Serial Device\n");
        return -1;
    }

    /* シリアルポートの設定 */
    tio.c_cflag = B9600 | CS8 | CREAD | CLOCAL ;	/* control modes */
    tio.c_iflag = 0;					/* input modes   */
    tio.c_oflag = 0;					/* output modes  */
    tio.c_lflag = 0;					/* local modes   */
    tio.c_cc[VMIN] =0;		/* Minimum number of characters for noncanonical read, 0にする */
    tio.c_cc[VTIME] =1;		/* Timeout in deciseconds for noncanonical read, 1以上にする */

    tcsetattr(fd, TCSANOW, &tio);	/* 端末に関連したパラメータの設定(ハードウェアの設定に必要), ただちに変更を有効 */

    if(strcmp(argv[2],"-s")==0){
        /* 送信のみ */
        write(fd,argv[1],atoi(argv[3]));
    }

    else if(strcmp(argv[2],"-r")==0){
        /* 送受信 */
        write(fd,argv[1],atoi(argv[3]));
        while(callback[0]=='Z'){
            fgets(callback,sizeof(callback),fpp);
        }
        printf("%s\n",callback);
    }

    else{
        printf("Only SEND is,         $ ./meade :Mn# -s 4\n");
        printf("SEND and RECEIVE ars, $ ./meade :GL# -r 4\n");
    }
  
    /* ファイルクローズ */
    close(fd);
    fclose(fpp);

    return 0;
}
