#!/bin/bash
#canopus.sh

# Vmag>1.5 の恒星リスト

#アケルナル, Achernar, 0.50
ACHERNAR_RA=":Sr01:37:43# -r 12"
ACHERNAR_DEC=":Sd-57*14:12# -r 13"

#アルデバラン, Aldebaran, 0.85 (variable)
ALDEBARAN_RA=":Sr04:35:55# -r 12"
ALDEBARAN_DEC=":Sd+16*30:33# -r 13"

#リゲル, Rigel, 0.12
RIGEL_RA=":Sr05:14:32# -r 12"
RIGEL_DEC=":Sd-08*12:06# -r 13"

#カペラ, Capella, 0.08 (doublet)
CAPERA_RA=":Sr05:16:41# -r 12"
CAPERA_DEC=":Sd+45*59:53# -r 13"

#ベテルギウス, Betelgeuse, 0.58 (variable)
BETELGEUSE_RA=":Sr05:55:10# -r 12"
BETELGEUSE_DEC=":Sd+07*24:25# -r 13"

#カノープス, Canopus, -0.72
CANOPUS_RA=":Sr06:23:57# -r 12"
CANOPUS_DEC=":Sd-52*41:45# -r 13"

#シリウス, Sirius, -1.47
SIRIUS_RA=":Sr06:45:09# -r 12"
SIRIUS_DEC=":Sd-16*42:58# -r 13"

#プロキオン, Procyon, 0.34
PROCYON_RA=":Sr07:39:18# -r 12"
PROCYON_DEC=":Sd+05*13:29 -r 13"

#ポルックス, Pollux, 1.15
POLLUX_RA=":Sr07:45:19# -r 12"
POLLUX_DEC=":Sd+28*01:35# -r 13"

#レグルス, Regulus, 1.35
REGULUS_RA=":Sr10:08:22# -r 12"
REGURUS_DEC=":Sd+11*58:02# -r 13"

#アクルックス, Acrux, 0.77 (doublet)
ACRUX_RA=":Sr12:26:36# -r 12"
ACRUX_DEC=":Sd-63*05:57# -r 13"

#ベクルックス, Becrux, 1.30
BECRUX_RA=":Sr12:47:23# -r 12"
BECRUX_DEC=":Sd-59*41:19# -r 13"

#スピカ, Spica, 1.04
SPICA_RA=":Sr13:25:11# -r 12"
SPICA_DEC=":Sd-11*09:41# -r 13"

#ハダル, Hadar, 0.61
HADAR_RA=":Sr14:03:49# -r 12"
HADAR_DEC=":Sd-60*22:23# -r 13"

#アークトゥルス, Arcturus, -0.04 (variable)
ARCTURUS_RA=":Sr14:15:40# -r 12"
ARCTURUS_DEC=":Sd+19*10:56# -r 13"

#アルファケンタウリB, Alpha Centauri B, 1.34
ALPHACENTAURIB_RA=":Sr14:39:35# -r 12"
ALPHACENTAURIB_DEC=":Sd-60*50:13# -r 13"

#アルファケンタウリA, Alpha Centauri A, -0.01
ALPHACENTAURIA_RA=":Sr14:39:37# -r 12"
ALPHACENTAURIA_DEC=":Sd-60*50:02# -r 13"

#アンタレス, Antares, 1.09 (variable)
ANTARES_RA=":Sr16:29:24# -r 12"
ANTARES_DEC=":Sd-26*25:55# -r 13"

#ベガ, Vega, 0.03
VEGA_RA=":Sr18:36:56# -r 12"
VEGA_DEC=":Sd+38*47:01# -r 13"

#アルタイル, Altair, 0.77
ALTAIR_RA=":Sr19:50:47# -r 12"
ALTAIR_DEC=":Sd+08*52:06# -r 13"

#デネブ, Deneb, 1.25
DENEB_RA=":Sr20:41:26# -r 12"
DENEB_DEC=":Sd+45*16:49# -r 13"

#フォーマルハウト, Formalhaut, 1.16
FORMALHAUT_RA=":Sr22:57:39# -r 12"
FORMALHAUT_DEC=":Sd-29*37:20# -r 13"

#月
MOON_RA=":Sr22:49:32# -r 12"
MOON_DEC=":Sd-02*25:49# -r 13"

#木星
JUPITER_RA=":Sr03:50:25# -r 12"
JUPITER_DEC=":Sd+19*18:43# -r 13"


#Ubuntuのバグ対策。シリアルポートの設定を変更。
stty -F /dev/ttyUSB0 clocal
#ディレクトリの移動 for sextractor
cd /program/LX200/

#望遠鏡の最大駆動速度を2degree/secに設定しカノープスを導入
rm -rf /program/LX200/command/lx200.sh
printf "#!/bin/bash\n
/program/LX200/meade :Sw2# -s 5\n
/program/LX200/meade $ALTAIR_RA\n
/program/LX200/meade $ALTAIR_DEC\n
/program/LX200/meade :MS# -r 4\n" >> /program/LX200/command/lx200.sh
sh /program/LX200/command/lx200.sh

echo "POINTING AUTO SUCCESSFUL"
exit 0
